gtkmm: Gtk::EventController Class Reference

gtkmm 3.24.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::EventController Class Reference
Event Controllers and Gestures

Self-contained handler of series of events. More...

`#include <gtkmm/eventcontroller.h>`

Inheritance diagram for Gtk::EventController:
[legend]

## Public Member Functions
| EventController (EventController&& src) noexcept
EventController& | operator= (EventController&& src) noexcept
| ~EventController () noexcept override
GtkEventController* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkEventController* | gobj () const
| Provides access to the underlying C GObject. More...
GtkEventController* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Widget* | get_widget ()
| Returns the Gtk::Widget this controller relates to. More...
const Widget* | get_widget () const
| Returns the Gtk::Widget this controller relates to. More...
bool | handle_event (const GdkEvent* event)
| Feeds an events into controller, so it can be interpreted and the controller actions triggered. More...
void | reset ()
| Resets the controller to a clean state. More...
PropagationPhase | get_propagation_phase () const
| Gets the propagation phase at which controller handles events. More...
void | set_propagation_phase (PropagationPhase phase)
| Sets the propagation phase at which a controller handles events. More...
Glib::PropertyProxy_ReadOnly< Widget*> | property_widget () const
| The widget receiving the Gdk::Events that the controller will handle. More...
Glib::PropertyProxy< PropagationPhase > | property_propagation_phase ()
| The propagation phase at which this controller will handle events. More...
Glib::PropertyProxy_ReadOnly< PropagationPhase > | property_propagation_phase () const
| The propagation phase at which this controller will handle events. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void > &&slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, sigc::slot< void > &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| EventController ()
| There is no create() method that corresponds to this constructor, because only derived classes shall be created. More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::EventController > | wrap (GtkEventController* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

Self-contained handler of series of events.

This is an abstract base class, low-level implementation for event controllers. Those react to a series of GdkEvents, and possibly trigger actions as a consequence of those.

Since gtkmm 3.14:

## Constructor & Destructor Documentation

## ◆ EventController() [1/2]

Gtk::EventController::EventController | ( | EventController&& | src | ) |
| noexcept

## ◆ ~EventController()

Gtk::EventController::~EventController | ( |  | ) |
| overridenoexcept

## ◆ EventController() [2/2]

Gtk::EventController::EventController | ( |  | ) |
| protected

There is no create() method that corresponds to this constructor, because only derived classes shall be created.

## Member Function Documentation

## ◆ get_propagation_phase()

PropagationPhase Gtk::EventController::get_propagation_phase | ( |  | ) | const

Gets the propagation phase at which controller handles events.

Since gtkmm 3.14:

Returns
  The propagation phase.

## ◆ get_type()

static GType Gtk::EventController::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ get_widget() [1/2]

Widget* Gtk::EventController::get_widget | ( |  | ) |

Returns the Gtk::Widget this controller relates to.

Since gtkmm 3.14:

Returns
  A Gtk::Widget.

## ◆ get_widget() [2/2]

const Widget* Gtk::EventController::get_widget | ( |  | ) | const

Returns the Gtk::Widget this controller relates to.

Since gtkmm 3.14:

Returns
  A Gtk::Widget.

## ◆ gobj() [1/2]

GtkEventController* Gtk::EventController::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkEventController* Gtk::EventController::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkEventController* Gtk::EventController::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ handle_event()

bool Gtk::EventController::handle_event | ( | const GdkEvent * | event | ) |

Feeds an events into controller, so it can be interpreted and the controller actions triggered.

Since gtkmm 3.14:

Parameters

  event | A Gdk::Event.

Returns
  `true` if the event was potentially useful to trigger the controller action.

## ◆ operator=()

EventController& Gtk::EventController::operator= | ( | EventController&& | src | ) |
| noexcept

## ◆ property_propagation_phase() [1/2]

Glib::PropertyProxy< PropagationPhase > Gtk::EventController::property_propagation_phase | ( |  | ) |

The propagation phase at which this controller will handle events.

Since gtkmm 3.14:

Default value: Gtk::PHASE_BUBBLE

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_propagation_phase() [2/2]

Glib::PropertyProxy_ReadOnly< PropagationPhase > Gtk::EventController::property_propagation_phase | ( |  | ) | const

The propagation phase at which this controller will handle events.

Since gtkmm 3.14:

Default value: Gtk::PHASE_BUBBLE

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_widget()

Glib::PropertyProxy_ReadOnly< Widget* > Gtk::EventController::property_widget | ( |  | ) | const

The widget receiving the Gdk::Events that the controller will handle.

Since gtkmm 3.14:

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ reset()

void Gtk::EventController::reset | ( |  | ) |

Resets the controller to a clean state.

Every interaction the controller did through Gtk::EventController::signal_handle_event() will be dropped at this point.

Since gtkmm 3.14:

## ◆ set_propagation_phase()

void Gtk::EventController::set_propagation_phase | ( | PropagationPhase | phase | ) |

Sets the propagation phase at which a controller handles events.

If phase is Gtk::PHASE_NONE, no automatic event handling will be performed, but other additional gesture maintenance will. In that phase, the events can be managed by calling handle_event().

Since gtkmm 3.14:

Parameters

  phase | A propagation phase.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::EventController > wrap | ( | GtkEventController * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.